diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/Implies b/nptl/sysdeps/unix/sysv/linux/x86_64/Implies
deleted file mode 100644
index ccc7eaa..0000000
--- a/nptl/sysdeps/unix/sysv/linux/x86_64/Implies
+++ /dev/null
@@ -1 +0,0 @@
-unix/sysv/linux/x86
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/cancellation.S b/sysdeps/unix/sysv/linux/x86_64/cancellation.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/cancellation.S
rename to sysdeps/unix/sysv/linux/x86_64/cancellation.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/libc-cancellation.S b/sysdeps/unix/sysv/linux/x86_64/libc-cancellation.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/libc-cancellation.S
rename to sysdeps/unix/sysv/linux/x86_64/libc-cancellation.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/libc-lowlevellock.S b/sysdeps/unix/sysv/linux/x86_64/libc-lowlevellock.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/libc-lowlevellock.S
rename to sysdeps/unix/sysv/linux/x86_64/libc-lowlevellock.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/librt-cancellation.S b/sysdeps/unix/sysv/linux/x86_64/librt-cancellation.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/librt-cancellation.S
rename to sysdeps/unix/sysv/linux/x86_64/librt-cancellation.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/lowlevellock.S b/sysdeps/unix/sysv/linux/x86_64/lowlevellock.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/lowlevellock.S
rename to sysdeps/unix/sysv/linux/x86_64/lowlevellock.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/lowlevellock.h b/sysdeps/unix/sysv/linux/x86_64/lowlevellock.h
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/lowlevellock.h
rename to sysdeps/unix/sysv/linux/x86_64/lowlevellock.h
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S b/sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S
rename to sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_barrier_wait.S b/sysdeps/unix/sysv/linux/x86_64/pthread_barrier_wait.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_barrier_wait.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_barrier_wait.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S b/sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S b/sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S b/sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S b/sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_once.S b/sysdeps/unix/sysv/linux/x86_64/pthread_once.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_once.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_once.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S b/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S b/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S b/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_unlock.S b/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_unlock.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_unlock.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_unlock.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S b/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S
rename to sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_setaffinity.c b/sysdeps/unix/sysv/linux/x86_64/pthread_setaffinity.c
similarity index 86%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/pthread_setaffinity.c
rename to sysdeps/unix/sysv/linux/x86_64/pthread_setaffinity.c
index 640d304..a7bbe38 100644
--- a/nptl/sysdeps/unix/sysv/linux/x86_64/pthread_setaffinity.c
+++ b/sysdeps/unix/sysv/linux/x86_64/pthread_setaffinity.c
@@ -11,4 +11,4 @@
 				   header.vgetcpu_cache[1])));		\
   } while (0)
 
-#include "../pthread_setaffinity.c"
+#include <sysdeps/unix/sysv/linux/pthread_setaffinity.c>
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/sem_post.S b/sysdeps/unix/sysv/linux/x86_64/sem_post.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/sem_post.S
rename to sysdeps/unix/sysv/linux/x86_64/sem_post.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S b/sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S
rename to sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/sem_trywait.S b/sysdeps/unix/sysv/linux/x86_64/sem_trywait.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/sem_trywait.S
rename to sysdeps/unix/sysv/linux/x86_64/sem_trywait.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/sem_wait.S b/sysdeps/unix/sysv/linux/x86_64/sem_wait.S
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/sem_wait.S
rename to sysdeps/unix/sysv/linux/x86_64/sem_wait.S
diff --git a/nptl/sysdeps/unix/sysv/linux/x86_64/sysdep-cancel.h b/sysdeps/unix/sysv/linux/x86_64/sysdep-cancel.h
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86_64/sysdep-cancel.h
rename to sysdeps/unix/sysv/linux/x86_64/sysdep-cancel.h