diff --git a/nptl/sysdeps/unix/sysv/linux/x86/Makefile b/nptl/sysdeps/unix/sysv/linux/x86/Makefile
deleted file mode 100644
index 61b7552..0000000
--- a/nptl/sysdeps/unix/sysv/linux/x86/Makefile
+++ /dev/null
@@ -1,3 +0,0 @@
-libpthread-sysdep_routines += init-arch
-libpthread-sysdep_routines += elision-lock elision-unlock elision-timed \
-			      elision-trylock
diff --git a/sysdeps/unix/sysv/linux/x86/Makefile b/sysdeps/unix/sysv/linux/x86/Makefile
index 6412a9e..012125f 100644
--- a/sysdeps/unix/sysv/linux/x86/Makefile
+++ b/sysdeps/unix/sysv/linux/x86/Makefile
@@ -16,3 +16,9 @@ abi-x32-ld-soname := ld-linux-x32.so.2
 ifeq ($(subdir),misc)
 sysdep_headers += sys/elf.h sys/perm.h sys/reg.h sys/vm86.h sys/debugreg.h sys/io.h
 endif
+
+ifeq ($(subdir),nptl)
+libpthread-sysdep_routines += init-arch
+libpthread-sysdep_routines += elision-lock elision-unlock elision-timed \
+			      elision-trylock
+endif
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/elision-conf.c b/sysdeps/unix/sysv/linux/x86/elision-conf.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/elision-conf.c
rename to sysdeps/unix/sysv/linux/x86/elision-conf.c
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/elision-conf.h b/sysdeps/unix/sysv/linux/x86/elision-conf.h
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/elision-conf.h
rename to sysdeps/unix/sysv/linux/x86/elision-conf.h
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/elision-lock.c b/sysdeps/unix/sysv/linux/x86/elision-lock.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/elision-lock.c
rename to sysdeps/unix/sysv/linux/x86/elision-lock.c
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/elision-timed.c b/sysdeps/unix/sysv/linux/x86/elision-timed.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/elision-timed.c
rename to sysdeps/unix/sysv/linux/x86/elision-timed.c
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/elision-trylock.c b/sysdeps/unix/sysv/linux/x86/elision-trylock.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/elision-trylock.c
rename to sysdeps/unix/sysv/linux/x86/elision-trylock.c
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/elision-unlock.c b/sysdeps/unix/sysv/linux/x86/elision-unlock.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/elision-unlock.c
rename to sysdeps/unix/sysv/linux/x86/elision-unlock.c
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/force-elision.h b/sysdeps/unix/sysv/linux/x86/force-elision.h
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/force-elision.h
rename to sysdeps/unix/sysv/linux/x86/force-elision.h
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/hle.h b/sysdeps/unix/sysv/linux/x86/hle.h
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/hle.h
rename to sysdeps/unix/sysv/linux/x86/hle.h
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/init-arch.c b/sysdeps/unix/sysv/linux/x86/init-arch.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/init-arch.c
rename to sysdeps/unix/sysv/linux/x86/init-arch.c
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/init-arch.h b/sysdeps/unix/sysv/linux/x86/init-arch.h
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/init-arch.h
rename to sysdeps/unix/sysv/linux/x86/init-arch.h
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/pthread_mutex_cond_lock.c b/sysdeps/unix/sysv/linux/x86/pthread_mutex_cond_lock.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/pthread_mutex_cond_lock.c
rename to sysdeps/unix/sysv/linux/x86/pthread_mutex_cond_lock.c
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/pthread_mutex_lock.c b/sysdeps/unix/sysv/linux/x86/pthread_mutex_lock.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/pthread_mutex_lock.c
rename to sysdeps/unix/sysv/linux/x86/pthread_mutex_lock.c
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/pthread_mutex_timedlock.c b/sysdeps/unix/sysv/linux/x86/pthread_mutex_timedlock.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/pthread_mutex_timedlock.c
rename to sysdeps/unix/sysv/linux/x86/pthread_mutex_timedlock.c
diff --git a/nptl/sysdeps/unix/sysv/linux/x86/pthread_mutex_trylock.c b/sysdeps/unix/sysv/linux/x86/pthread_mutex_trylock.c
similarity index 100%
rename from nptl/sysdeps/unix/sysv/linux/x86/pthread_mutex_trylock.c
rename to sysdeps/unix/sysv/linux/x86/pthread_mutex_trylock.c