diff --git a/nptl/sysdeps/unix/sysv/linux/s390/s390-32/pt-vfork.S b/nptl/sysdeps/unix/sysv/linux/s390/s390-32/pt-vfork.S
deleted file mode 100644
index 00ed992..0000000
--- a/nptl/sysdeps/unix/sysv/linux/s390/s390-32/pt-vfork.S
+++ /dev/null
@@ -1,53 +0,0 @@
-/* Copyright (C) 2003-2014 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Martin Schwidefsky <schwidefsky@de.ibm.com>, 2003.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <sysdep.h>
-#define _ERRNO_H	1
-#include <bits/errno.h>
-#include <kernel-features.h>
-#include <bits/wordsize.h>
-#include <tcb-offsets.h>
-
-/* Clone the calling process, but without copying the whole address space.
-   The calling process is suspended until the new process exits or is
-   replaced by a call to `execve'.  Return -1 for errors, 0 to the new process,
-   and the process ID of the new process to the old process.  */
-
-ENTRY (__vfork)
-	ear	%r4,%a0
-	l	%r3,PID(%r4)
-	lcr	%r1,%r3
-	st	%r1,PID(%r4)
-
-	/* Do vfork system call.  */
-	svc	SYS_ify (vfork)
-
-	ltr	%r2,%r2
-	je	1f
-	st	%r3,PID(%r4)
-1:
-	/* Check for error.  */
-	lhi	%r4,-4095
-	clr	%r2,%r4
-	jnl	SYSCALL_ERROR_LABEL
-
-	/* Normal return.  */
-	br	%r14
-PSEUDO_END(__vfork)
-
-weak_alias (__vfork, vfork)
diff --git a/nptl/sysdeps/unix/sysv/linux/s390/s390-64/pt-vfork.S b/nptl/sysdeps/unix/sysv/linux/s390/s390-64/pt-vfork.S
deleted file mode 100644
index 97f82f0..0000000
--- a/nptl/sysdeps/unix/sysv/linux/s390/s390-64/pt-vfork.S
+++ /dev/null
@@ -1,56 +0,0 @@
-/* Copyright (C) 2003-2014 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Martin Schwidefsky <schwidefsky@de.ibm.com>, 2003.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <sysdep.h>
-#define _ERRNO_H	1
-#include <bits/errno.h>
-#include <kernel-features.h>
-#include <bits/wordsize.h>
-#include <tcb-offsets.h>
-
-/* Clone the calling process, but without copying the whole address space.
-   The calling process is suspended until the new process exits or is
-   replaced by a call to `execve'.  Return -1 for errors, 0 to the new process,
-   and the process ID of the new process to the old process.  */
-
-ENTRY (__vfork)
-
-	ear	%r4,%a0
-	sllg	%r4,%r4,32
-	ear	%r4,%a1
-	l	%r3,PID(%r4)
-	lcr	%r1,%r3
-	st	%r1,PID(%r4)
-
-	/* Do vfork system call.  */
-	svc	SYS_ify (vfork)
-
-	ltgr	%r2,%r2
-	je	1f
-	st	%r3,PID(%r4)
-1:
-	/* Check for error.  */
-	lghi	%r4,-4095
-	clgr	%r2,%r4
-	jgnl	SYSCALL_ERROR_LABEL
-
-	/* Normal return.  */
-	br	%r14
-PSEUDO_END(__vfork)
-
-weak_alias (__vfork, vfork)
diff --git a/sysdeps/unix/sysv/linux/s390/s390-32/pt-vfork.S b/sysdeps/unix/sysv/linux/s390/s390-32/pt-vfork.S
new file mode 100644
index 0000000..65cc382
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/s390/s390-32/pt-vfork.S
@@ -0,0 +1 @@
+#include <sysdeps/unix/sysv/linux/alpha/pt-vfork.S>
diff --git a/sysdeps/unix/sysv/linux/s390/s390-32/syscalls.list b/sysdeps/unix/sysv/linux/s390/s390-32/syscalls.list
index e946d33..ce9f210 100644
--- a/sysdeps/unix/sysv/linux/s390/s390-32/syscalls.list
+++ b/sysdeps/unix/sysv/linux/s390/s390-32/syscalls.list
@@ -2,7 +2,6 @@
 
 oldgetrlimit	EXTRA	getrlimit	i:ip	__old_getrlimit	getrlimit@GLIBC_2.0
 oldsetrlimit	EXTRA	setrlimit	i:ip	__old_setrlimit	setrlimit@GLIBC_2.0
-vfork		-	vfork		0	__vfork		vfork
 
 prlimit64	EXTRA	prlimit64	i:iipp	prlimit64
 fanotify_mark	EXTRA	fanotify_mark	i:iiiiis	fanotify_mark
diff --git a/nptl/sysdeps/unix/sysv/linux/s390/s390-32/vfork.S b/sysdeps/unix/sysv/linux/s390/s390-32/vfork.S
similarity index 91%
rename from nptl/sysdeps/unix/sysv/linux/s390/s390-32/vfork.S
rename to sysdeps/unix/sysv/linux/s390/s390-32/vfork.S
index adf66be..42f66a6 100644
--- a/nptl/sysdeps/unix/sysv/linux/s390/s390-32/vfork.S
+++ b/sysdeps/unix/sysv/linux/s390/s390-32/vfork.S
@@ -28,7 +28,7 @@
    replaced by a call to `execve'.  Return -1 for errors, 0 to the new process,
    and the process ID of the new process to the old process.  */
 
-ENTRY (__vfork)
+ENTRY (__libc_vfork)
 	ear	%r4,%a0
 	lhi	%r1,1
 	icm	%r3,15,PID(%r4)
@@ -51,6 +51,10 @@ ENTRY (__vfork)
 
 	/* Normal return.  */
 	br	%r14
-PSEUDO_END(__vfork)
+PSEUDO_END (__libc_vfork)
+
+#if !NOT_IN_libc
+weak_alias (__libc_vfork, vfork)
+strong_alias (__libc_vfork, __vfork)
 libc_hidden_def (__vfork)
-weak_alias (__vfork, vfork)
+#endif
diff --git a/sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list b/sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list
index b826c5d..5b8c102 100644
--- a/sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list
+++ b/sysdeps/unix/sysv/linux/s390/s390-64/syscalls.list
@@ -1,7 +1,5 @@
 # File name	Caller	Syscall name	# args	Strong name	Weak names
 
-vfork		-	vfork		0	__vfork		vfork
-
 # semaphore and shm system calls
 msgctl		-	msgctl		i:iip	__msgctl	msgctl
 msgget		-	msgget		i:ii	__msgget	msgget
diff --git a/nptl/sysdeps/unix/sysv/linux/s390/s390-64/vfork.S b/sysdeps/unix/sysv/linux/s390/s390-64/vfork.S
similarity index 92%
rename from nptl/sysdeps/unix/sysv/linux/s390/s390-64/vfork.S
rename to sysdeps/unix/sysv/linux/s390/s390-64/vfork.S
index 4f7a0b5..918dcbf 100644
--- a/nptl/sysdeps/unix/sysv/linux/s390/s390-64/vfork.S
+++ b/sysdeps/unix/sysv/linux/s390/s390-64/vfork.S
@@ -28,8 +28,7 @@
    replaced by a call to `execve'.  Return -1 for errors, 0 to the new process,
    and the process ID of the new process to the old process.  */
 
-ENTRY (__vfork)
-
+ENTRY (__libc_vfork)
 	ear	%r4,%a0
 	sllg	%r4,%r4,32
 	ear	%r4,%a1
@@ -53,6 +52,10 @@ ENTRY (__vfork)
 
 	/* Normal return.  */
 	br	%r14
-PSEUDO_END(__vfork)
+PSEUDO_END (__libc_vfork)
+
+#if !NOT_IN_libc
+weak_alias (__libc_vfork, vfork)
+strong_alias (__libc_vfork, __vfork)
 libc_hidden_def (__vfork)
-weak_alias (__vfork, vfork)
+#endif