diff --git a/sysdeps/unix/sysv/linux/ia64/Makefile b/sysdeps/unix/sysv/linux/ia64/Makefile
index bbfd6a2..f1049c3 100644
--- a/sysdeps/unix/sysv/linux/ia64/Makefile
+++ b/sysdeps/unix/sysv/linux/ia64/Makefile
@@ -26,3 +26,7 @@ endif
 # This is a crude attempt to silence the compiler which complains about
 # then 'current' definition in the kernel headers.
 CPPFLAGS += -D_ASM_IA64_CURRENT_H
+
+ifeq ($(subdir),nptl)
+libpthread-sysdep_routines += __ia64_longjmp unwind_longjmp __sigstack_longjmp
+endif
diff --git a/sysdeps/unix/sysv/linux/ia64/Versions b/sysdeps/unix/sysv/linux/ia64/Versions
index 13d710a..b38d6ef 100644
--- a/sysdeps/unix/sysv/linux/ia64/Versions
+++ b/sysdeps/unix/sysv/linux/ia64/Versions
@@ -23,3 +23,16 @@ libc {
     getunwind;
   }
 }
+libpthread {
+  GLIBC_2.3.3 {
+    # Changed PTHREAD_STACK_MIN.
+    pthread_attr_setstack; pthread_attr_setstacksize;
+  }
+}
+librt {
+  GLIBC_2.3.3 {
+    # Changed timer_t.
+    timer_create; timer_delete; timer_getoverrun; timer_gettime;
+    timer_settime;
+  }
+}
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/__ia64_longjmp.S b/sysdeps/unix/sysv/linux/ia64/__ia64_longjmp.S
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/__ia64_longjmp.S
rename to sysdeps/unix/sysv/linux/ia64/__ia64_longjmp.S
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/__sigstack_longjmp.c b/sysdeps/unix/sysv/linux/ia64/__sigstack_longjmp.c
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/__sigstack_longjmp.c
rename to sysdeps/unix/sysv/linux/ia64/__sigstack_longjmp.c
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/c++-types.data b/sysdeps/unix/sysv/linux/ia64/c++-types.data
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/c++-types.data
rename to sysdeps/unix/sysv/linux/ia64/c++-types.data
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/dl-sysdep.h b/sysdeps/unix/sysv/linux/ia64/dl-sysdep.h
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/dl-sysdep.h
rename to sysdeps/unix/sysv/linux/ia64/dl-sysdep.h
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/ld.abilist b/sysdeps/unix/sysv/linux/ia64/ld.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/ld.abilist
rename to sysdeps/unix/sysv/linux/ia64/ld.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libBrokenLocale.abilist b/sysdeps/unix/sysv/linux/ia64/libBrokenLocale.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libBrokenLocale.abilist
rename to sysdeps/unix/sysv/linux/ia64/libBrokenLocale.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libanl.abilist b/sysdeps/unix/sysv/linux/ia64/libanl.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libanl.abilist
rename to sysdeps/unix/sysv/linux/ia64/libanl.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libc.abilist b/sysdeps/unix/sysv/linux/ia64/libc.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libc.abilist
rename to sysdeps/unix/sysv/linux/ia64/libc.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libcrypt.abilist b/sysdeps/unix/sysv/linux/ia64/libcrypt.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libcrypt.abilist
rename to sysdeps/unix/sysv/linux/ia64/libcrypt.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libdl.abilist b/sysdeps/unix/sysv/linux/ia64/libdl.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libdl.abilist
rename to sysdeps/unix/sysv/linux/ia64/libdl.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libm.abilist b/sysdeps/unix/sysv/linux/ia64/libm.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libm.abilist
rename to sysdeps/unix/sysv/linux/ia64/libm.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libnsl.abilist b/sysdeps/unix/sysv/linux/ia64/libnsl.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libnsl.abilist
rename to sysdeps/unix/sysv/linux/ia64/libnsl.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libpthread.abilist b/sysdeps/unix/sysv/linux/ia64/libpthread.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libpthread.abilist
rename to sysdeps/unix/sysv/linux/ia64/libpthread.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libresolv.abilist b/sysdeps/unix/sysv/linux/ia64/libresolv.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libresolv.abilist
rename to sysdeps/unix/sysv/linux/ia64/libresolv.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/librt.abilist b/sysdeps/unix/sysv/linux/ia64/librt.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/librt.abilist
rename to sysdeps/unix/sysv/linux/ia64/librt.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libthread_db.abilist b/sysdeps/unix/sysv/linux/ia64/libthread_db.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libthread_db.abilist
rename to sysdeps/unix/sysv/linux/ia64/libthread_db.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/libutil.abilist b/sysdeps/unix/sysv/linux/ia64/libutil.abilist
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/libutil.abilist
rename to sysdeps/unix/sysv/linux/ia64/libutil.abilist
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/localplt.data b/sysdeps/unix/sysv/linux/ia64/localplt.data
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/localplt.data
rename to sysdeps/unix/sysv/linux/ia64/localplt.data
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/lowlevellock.h b/sysdeps/unix/sysv/linux/ia64/lowlevellock.h
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/lowlevellock.h
rename to sysdeps/unix/sysv/linux/ia64/lowlevellock.h
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/Makefile b/sysdeps/unix/sysv/linux/ia64/nptl/Makefile
deleted file mode 100644
index ff98f1a..0000000
--- a/sysdeps/unix/sysv/linux/ia64/nptl/Makefile
+++ /dev/null
@@ -1,3 +0,0 @@
-ifeq ($(subdir),nptl)
-libpthread-sysdep_routines += __ia64_longjmp unwind_longjmp __sigstack_longjmp
-endif
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/Versions b/sysdeps/unix/sysv/linux/ia64/nptl/Versions
deleted file mode 100644
index 437c4da..0000000
--- a/sysdeps/unix/sysv/linux/ia64/nptl/Versions
+++ /dev/null
@@ -1,13 +0,0 @@
-libpthread {
-  GLIBC_2.3.3 {
-    # Changed PTHREAD_STACK_MIN.
-    pthread_attr_setstack; pthread_attr_setstacksize;
-  }
-}
-librt {
-  GLIBC_2.3.3 {
-    # Changed timer_t.
-    timer_create; timer_delete; timer_getoverrun; timer_gettime;
-    timer_settime;
-  }
-}
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/sysdep-cancel.h b/sysdeps/unix/sysv/linux/ia64/sysdep-cancel.h
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/sysdep-cancel.h
rename to sysdeps/unix/sysv/linux/ia64/sysdep-cancel.h
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/timer_create.c b/sysdeps/unix/sysv/linux/ia64/timer_create.c
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/timer_create.c
rename to sysdeps/unix/sysv/linux/ia64/timer_create.c
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/timer_delete.c b/sysdeps/unix/sysv/linux/ia64/timer_delete.c
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/timer_delete.c
rename to sysdeps/unix/sysv/linux/ia64/timer_delete.c
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/timer_getoverr.c b/sysdeps/unix/sysv/linux/ia64/timer_getoverr.c
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/timer_getoverr.c
rename to sysdeps/unix/sysv/linux/ia64/timer_getoverr.c
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/timer_gettime.c b/sysdeps/unix/sysv/linux/ia64/timer_gettime.c
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/timer_gettime.c
rename to sysdeps/unix/sysv/linux/ia64/timer_gettime.c
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/timer_settime.c b/sysdeps/unix/sysv/linux/ia64/timer_settime.c
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/timer_settime.c
rename to sysdeps/unix/sysv/linux/ia64/timer_settime.c
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/unwind-forcedunwind.c b/sysdeps/unix/sysv/linux/ia64/unwind-forcedunwind.c
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/unwind-forcedunwind.c
rename to sysdeps/unix/sysv/linux/ia64/unwind-forcedunwind.c
diff --git a/sysdeps/unix/sysv/linux/ia64/nptl/unwind_longjmp.c b/sysdeps/unix/sysv/linux/ia64/unwind_longjmp.c
similarity index 100%
rename from sysdeps/unix/sysv/linux/ia64/nptl/unwind_longjmp.c
rename to sysdeps/unix/sysv/linux/ia64/unwind_longjmp.c